.\" Automatically generated from an mdoc input file.  Do not edit.
.\"
.\" Copyright (c) 2023 Andrea Biscuola <a@abiscuola.com>
.\"
.\" Permission to use, copy, modify, and distribute this software for any
.\" purpose with or without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\" WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\" ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\" ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\" OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.TH "IRCTK-IRC" "n" "September 3, 2023" "OpenBSD 7.3" "n"
.nh
.if n .ad l
.SH "NAME"
\fBirctk-exts\fR
\- irctk extensions subsystem
.SH "SYNOPSIS"
\fBexts bootstrapped\fR
.PP
\fBexts init\fR
.PP
\fBexts killbyname\fR \fIname\fR
.PP
\fBexts list\fR
.PP
\fBexts load\fR \fIpath\fR \fIcb\fR
.PP
\fBexts newmsg\fR
.PP
\fBexts readmsg\fR \fIch\fR \fIcb\fR
.PP
\fBexts writemsg\fR \fImsg\fR
.SH "DESCRIPTION"
The exts namespace, takes care of loading, and running, irctk extension
executables.
The subsystem completely takes care of the extensions management, with
the only communications with the other layers defined by the exported
functions.
.PP
\fBexts bootstrapped\fR
checks, during application startup, if all the configured extensions are
started properly, before continuing with the other parts of the process.
.PP
\fBexts init\fR
initializes the subsystem, loading the extensions at startup, both from the
extension default directory and the irctk extensions configurations file.
.PP
\fBexts killbyname\fR
unloads an extension identified by the
\fIname\fR
it communicated to irctk.
All the unloaded extension related resources are cleared by this command.
.PP
\fBexts list\fR
provides a tcl list with all the extensions actually running.
Every extension is represented in the list by three fields, in the following
order:
.PP
.RS 6n
.PD 0
.TP 12n
Name
The extension name, as reported during the handshake.
.TP 12n
Version
Extension version number.
.TP 12n
Path
The extension executable file path.
.RE
.PD
.PP
\fBexts load\fR
runs a new extension from the file at
\fIpath\fR.
If the handshake between the application and the extension is successful,
messages coming from the extension are passed to the callback command
\fIcb\fR
after being processed.
.PP
\fBexts newmsg\fR
returns an empty dictionary ready to be filled to be sent to the extensions
subsystem.
.PP
\fBexts readmsg\fR
read a message from the extension channel
\fIch\fR
and passes it to the callback
\fIcb\fR
after processing it.
The callback is called with the form:
.nf
.sp
.RS 6n
$cb $msg
.RE
.fi
.PP
Where
\(lq$msg\(rq
is a dictionary containing all the values of the received message.
.PP
\fBexts writemsg\fR
is used to pass an extension message to be written to all the running extensions
from irctk.
The message is a dictionary containing the fields related to the message type.
A message can be of type irc or plumb.
Please refer to the extensions protocol specification for additional details.
.SH "RETURN VALUES"
\fBexts list\fR
returns the list of loaded extensions.
.PP
\fBexts killbyname\fR
always return the empty string.
.PP
\fBexts writemsg\fR
returns 0 on success or <0 if an error occur.
.PP
\fBexts load\fR
return 0 if the extension already exists, the new communication channel if
the load of the extension is successful and <0 if an error occur.
.SH "FILES"
.TP 45n
\fI${PREFIX}/libexec\fR
Default extensions directory.
.PD 0
.TP 45n
\fI${HOME}/.config/irctk/extensions.conf\fR
irctk(1)
loaded extensions save file.
.PD
.SH "SEE ALSO"
irctk(1),
irctk-gui(n),
irctk-irc(n),
irctk-irctk(n),
irctk-log(n)
.SH "AUTHORS"
Andrea Biscuola <\fIa@abiscuola.com\fR>
