.\" Automatically generated from an mdoc input file.  Do not edit.
.\"
.\" Copyright (c) 2023 Andrea Biscuola <a@abiscuola.com>
.\"
.\" Permission to use, copy, modify, and distribute this software for any
.\" purpose with or without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\" WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\" ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\" ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\" OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.TH "IRCTK-GUI" "n" "September 3, 2023" "OpenBSD 7.3" "n"
.nh
.if n .ad l
.SH "NAME"
\fBirctk-gui\fR
\- graphical user interface
.SH "SYNOPSIS"
\fBgui adduser\fR \fIid nick\fR
.PP
\fBgui away\fR \fIid status\fR
.PP
\fBgui changech\fR \fIid\fR
.PP
\fBgui closechannel\fR \fIid\fR
.PP
\fBgui displaymsg\fR \fImsg nick id level datetime\fR
.PP
\fBgui displaytopic\fR \fIid datetime topic\fR
.PP
\fBgui init\fR
.PP
\fBgui newchanneltab\fR \fIfd nick parent id channel\fR
.PP
\fBgui newprivatetab\fR \fIfd nick parent id channel\fR
.PP
\fBgui newreadtab\fR \fIparent id channel\fR
.PP
\fBgui newserver\fR \fIitem\fR
.PP
\fBgui newservertab\fR \fIfd nick network id\fR
.PP
\fBgui onexit\fR
.PP
\fBgui privatechat\fR \fIfd id\fR
.PP
\fBgui quiet\fR
.PP
\fBgui raisewin\fR
.PP
\fBgui removeuser\fR \fIid nick\fR
.PP
\fBgui savefont\fR \fIsets\fR
.PP
\fBgui setmode\fR \fIid nick mode\fR
.PP
\fBgui showmode\fR
.PP
\fBgui updateuser\fR \fIid oldnick newnick\fR
.SH "DESCRIPTION"
The gui namespace, takes care of handling everything related to the user
interface of
irctk(1).
It sits on top of the application's stack, communicating with the irctk
middleware and, on some occasions, with the lower level libraries.
.PP
\fBgui init\fR
is called during the
irctk(1)
startup, to initialize the main user interface and drawing the main window
on the screen.
\fBgui onexit\fR,
on the other hand, is called when the user quits the application,
triggering all the cleanup commands from the other layers.
.PP
The
\fBgui newchanneltab\fR,
\fBgui newprivatetab\fR,
\fBgui newprivatechat\fR,
\fBgui newreadtab\fR
and
\fBgui newreadtab\fR
are all used to create a new channel in the interface.
A channel may be of different types:
.TP 9n
server
The channel where the network messages and the messages without a
clear target are written to.
Useful for logging of the server itself.
Can be also used, in general, to run commands related to the network.
Generally is represented as a root node in the
\(lqservers\(rq
treeview.
.TP 9n
channel
A channel the user explicitly join.
It's created when the application receives the confirmation of the user
successfully joining a specific channel.
It also shows the list of users present in the new channel itself.
.TP 9n
private
A private communication with another user.
Created when the user receive a direct message, or after the user issues
a QUERY command in one of the prompts.
.TP 9n
read
A read-only channel.
Generally created when an extension wants to write something in output
and a channel with the given name does not exists.
It can be used only to show informations, it's not possible to interact with
it, outside explicitly closing it.
.PP
\fBgui closechannel\fR
destroy the interface components related to the channel identified by
\fIid\fR
and remove the channel from the treeview.
.PP
\fBgui displaytopic\fR
shows the channel topic on the top editor line dedicated to it and in the
chat panel whenever the user joins a channel, or the topic is changed.
.PP
\fBgui displaymsg\fR
posts the text in
\fImsg\fR
coming from a server in the channel identified
by the given
\fIid\fR.
The message is written showing the given
\fInick\fR
and a
\fIdatetime\fR
timestamp with the hour, minute and second the message is
received.
The level is used to color the message, and the channel in the treeview
with different colors:
.TP 9n
mention
The message mentions the user in it's text and it will be written in
purple.
Also, the channel name in the servers treeview will be shown as
purple.
.TP 9n
message
A chat message, coming from another user.
The channel name is colored in orange.
.TP 9n
info
A message coming from the server, like
\(lqfoo has joined\(rq,
or
\(lqbar has quit\(rq.
The channel is colored in blue.
.PP
If the quiet mode is active through, by being activated with the
\fBgui quiet\fR
command, messages of level info are suppressed.
The current mode may be visualized with
\fBgui showmode\fR.
.PP
\fBgui adduser\fR
and
\fBgui removeuser\fR
updates the users list of the channel
\fIid\fR
joined by the application user, by, respectively, adding a new user
or removing it.
.PP
\(lqgui away\(rq
marks the user in the various channel of the server identified by
\fIid\fR
as grey if
\fIstatus\fR
is 1
or enabled if
\fIstatus\fR
is 0.
.PP
\fBgui setmode\fR
marks the given
\fInick\fR
in the channel
\fIid\fR
with the provided irc mode.
If
\fInick\fR
is an operator, it's visualized in green.
.PP
\fBgui changech\fR
and
\fBgui raisewin\fR
are function used, generally, by the extensions.
Those are mapped by the custom IRC SWITCH and RAISE
commands.
SWITCH, select, programmatically, the channel identified by
\fIid\fR
and RAISE, show the application window.
.PP
\fBgui savefont\fR
saves the current font settings in the fonts configurations file.
.SH "FILES"
.TP 39n
\fI${HOME}/.config/irctk/font.conf\fR
Font configurations file
.SH "SEE ALSO"
irctk(1),
irctk-exts(n),
irctk-irc(n),
irctk-irctk(n),
irctk-log(n)
.SH "AUTHORS"
Andrea Biscuola <\fIa@abiscuola.com\fR>
