.\" Automatically generated from an mdoc input file.  Do not edit.
.\"
.\" Copyright (c) 2023 Andrea Biscuola <a@abiscuola.com>
.\"
.\" Permission to use, copy, modify, and distribute this software for any
.\" purpose with or without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\" WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\" ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\" ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\" OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.TH "IRCTK-IRCTK" "n" "August 24, 2023" "OpenBSD 7.3" "n"
.nh
.if n .ad l
.SH "NAME"
\fBirctk-irctk\fR
\- core processing namespace
.SH "SYNOPSIS"
\fBirctk connect\fR \fInetwork nick name pass cmd oldch\fR
.PP
\fBirctk extmsg\fR \fImsg\fR
.PP
\fBirctk findnetwork\fR \fIid\fR
.PP
\fBirctk getnetwork\fR \fInetwork\fR
.PP
\fBirctk init\fR
.PP
\fBirctk ischanrd\fR \fIchan channel\fR
.PP
\fBirctk killconnection\fR \fIid\fR
.PP
\fBirctk onexit\fR
.PP
\fBirctk partch\fR \fIchan channel\fR
.PP
\fBirctk pingserver\fR \fIchan\fR
.PP
\fBirctk privatechan\fR \fIchan nick\fR
.PP
\fBirctk reconnect\fR \fIchan\fR
.PP
\fBirctk quitserver\fR \fIchan\fR
.PP
\fBirctk save\fR \fInetwork nick name pass cmd\fR
.PP
\fBirctk writemsg\fR \fIchan id tags text loop\fR
.SH "DESCRIPTION"
The irctk namespace represent the heart of the whole
irctk(1)
application.
Input message processing, message sending, connections and channels
management along with the gluing with all the other namespaces
take place here.
It is initialized by calling the
\fBirctk init\fR
command and terminated upon application exiting with
\fBirctk onexit\fR.
.PP
After the initialization,
\fBirctk connect\fR
is called, serially, for all the IRC servers saved in the related configurations
file, also automatically joining all the channels saved from the previous
session.
A connection to an IRC server is initiated using the command specified in
\fIcmd\fR.
If the connection is successful, the command will proceed with requesting
IRCv3 capabilities and performing a login for the user.
.PP
If a connection dies, a reconnection is tried automatically with the
\fBirctk reconnect\fR
command, with the old details and channels automatically transported
to the new connection, if successfull.
.PP
\fBirctk killconnection\fR
explicitly kill an existing connection and start a reconnection process.
.PP
Once the login process is completed and the user joined one or more
channels,
\fBirctk writemsg\fR
is called from the GUI to send messages to an IRC server.
The message specified in
\fItext\fR
is sent to the target identified by
\fIid\fR
in its numeric form, on the server whose connection channel is
\fIchan\fR.
The message will be enriched with the given
\fItags\fR,
a dictionary containing a series of key-value pairs identifying IRCv3 tags.
The
\fIloop\fR
variable must be set to 0, if we are sure that the message will not cause
a loop with the running extensions, or 1 if it is not the case.
The effect is, in the end, that the message will not be forwarded to the
extensions subsystem.
.PP
\fBirctk extmsg\fR
is the command called by the extensions subsystem when an extension
sends an irc message to the application.
The function take care of preparing and injecting the message in the
writing flow, to be sent to the server and shown to the user in the
interface.
.PP
\fBirctk findnetwork\fR
finds the communication channel associated with the network
\fIid\fR.
passed as argument.
.PP
\fBirctk partch\fR
frees all the resources associated with a specific channel upon leaving
it.
.PP
\fBirctk ischanrd\fR
Check if the
\fIchannel\fR
in the network identified by the communication channel
\fIchan\fR
is of type
\fBread only\fR.
.PP
\fBirctk quitserver\fR
is used to destroy all the resources related to a specific server connection,
both from the running application and from the disk.
The server details are deleted forever.
.PP
\fBirctk getnetwork\fR
command, reads the
\fInetwork\fR
connection details from it's configurations file.
.PP
\fBirctk save\fR
is called whenever the application must store a connection informations
on its configuration file.
.PP
\fBirctk privatechan\fR
is called to create a private communication channel between the application
user and the IRC user identified by
\fInick\fR
.PP
\fBirctk pingserver\fR
is used to periodically send a PING message, to check if the connection
is still alive.
.SH "RETURN VALUES"
\fBirctk findnetwork\fR
return the communication channel of the network identified by
\fIid\fR
or an empty list if nothing is found.
.PP
\fBirctk ischanrd\fR
return 1 if the channel is read only, or 0 if not.
.PP
\fBirctk getnetwork\fR
return the dictionary with the configurations for the given
\fInetwork\fR.
.PP
\fBirctk connect\fR
return the new communication channel for the network.
.SH "FILES"
.TP 50n
\fI${HOME}/.config/irctk/auto/$net/connect.conf\fR
Network configuration for automatic connection at startup.
.PD 0
.TP 50n
\fI${HOME}/.config/irctk/auto/$net/join.conf\fR
List of channels to join at startup.
.PD
.SH "SEE ALSO"
irctk(1),
irctk-exts(n),
irctk-gui(n),
irctk-irc(n),
irctk-log(n)
.SH "AUTHORS"
Andrea Biscuola <\fIa@abiscuola.com\fR>
