.\" Automatically generated from an mdoc input file.  Do not edit.
.\"
.\" Copyright (c) 2023 Andrea Biscuola <a@abiscuola.com>
.\"
.\" Permission to use, copy, modify, and distribute this software for any
.\" purpose with or without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\" WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\" ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\" ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\" OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.TH "IRCTK-IRC" "n" "August 18, 2023" "OpenBSD 7.3" "n"
.nh
.if n .ad l
.SH "NAME"
\fBirctk-log\fR
\- irctk irc conversations logging facility
.SH "SYNOPSIS"
\fBlog close\fR \fIchan\fR
.PP
\fBlog console\fR \fItext\fR
.PP
\fBlog open\fR \fInetwork channel\fR
.PP
\fBlog write\fR \fIchan nick msg timestamp\fR
.SH "DESCRIPTION"
The log namespace implements the functions to open, write and close a channel,
or private conversation, log file.
.PP
\fBlog open\fR
will open, or create, a new log file for
\fIchannel\fR
in the directory of the specified
\fInetwork\fR.
.PP
\fBlog write\fR
writes a new log entry in the file identified by
\fIchan\fR.
\fInick\fR
is the nickname of the user that sent the message,
\fImsg\fR
is the message text itself and
\fItimestamp\fR
is the date and time of the message as seconds from the UNIX epoch.
The message format as written in the log file is as following:
.nf
.sp
.RS 6n
YYYY-mm-ddTHH:MM:SS <nick>: message
.RE
.fi
.PP
\fBlog console\fR
writes a generic log message on the application standard error channel.
.PP
\fBlog close\fR
takes care of closing and releasing any resources that was in use by
\fIchan\fR.
.SH "RETURN VALUES"
\fBlog open\fR
returns the channel descriptor for the opened file.
.PP
\fBlog write\fR
and
\fBlog close\fR
does not return any value.
.SH "FILES"
.TP 26n
${HOME}/irc/logs
IRC logs directory.
.SH "SEE ALSO"
irctk(1),
irctk-exts(n),
irctk-gui(n),
irctk-irc(n),
irctk-irctk(n)
.SH "AUTHORS"
Andrea Biscuola <\fIa@abiscuola.com\fR>
