IRCTK-GUI(n) - n

# NAME

**irctk-gui** - graphical user interface

# SYNOPSIS

**gui adduser** *id nick*

**gui away** *id status*

**gui changech** *id*

**gui closechannel** *id*

**gui displaymsg** *msg nick id level datetime*

**gui displaytopic** *id datetime topic*

**gui init**

**gui newchanneltab** *fd nick parent id channel*

**gui newprivatetab** *fd nick parent id channel*

**gui newreadtab** *parent id channel*

**gui newserver** *item*

**gui newservertab** *fd nick network id*

**gui onexit**

**gui privatechat** *fd id*

**gui quiet**

**gui raisewin**

**gui removeuser** *id nick*

**gui savefont** *sets*

**gui setmode** *id nick mode*

**gui showmode**

**gui updateuser** *id oldnick newnick*

# DESCRIPTION

The gui namespace, takes care of handling everything related to the user
interface of
irctk(1).
It sits on top of the application's stack, communicating with the irctk
middleware and, on some occasions, with the lower level libraries.

**gui init**
is called during the
irctk(1)
startup, to initialize the main user interface and drawing the main window
on the screen.
**gui onexit**,
on the other hand, is called when the user quits the application,
triggering all the cleanup commands from the other layers.

The
**gui newchanneltab**,
**gui newprivatetab**,
**gui newprivatechat**,
**gui newreadtab**
and
**gui newreadtab**
are all used to create a new channel in the interface.
A channel may be of different types:

server

> The channel where the network messages and the messages without a
> clear target are written to.
> Useful for logging of the server itself.
> Can be also used, in general, to run commands related to the network.
> Generally is represented as a root node in the
> "servers"
> treeview.

channel

> A channel the user explicitly join.
> It's created when the application receives the confirmation of the user
> successfully joining a specific channel.
> It also shows the list of users present in the new channel itself.

private

> A private communication with another user.
> Created when the user receive a direct message, or after the user issues
> a QUERY command in one of the prompts.

read

> A read-only channel.
> Generally created when an extension wants to write something in output
> and a channel with the given name does not exists.
> It can be used only to show informations, it's not possible to interact with
> it, outside explicitly closing it.

**gui closechannel**
destroy the interface components related to the channel identified by
*id*
and remove the channel from the treeview.

**gui displaytopic**
shows the channel topic on the top editor line dedicated to it and in the
chat panel whenever the user joins a channel, or the topic is changed.

**gui displaymsg**
posts the text in
*msg*
coming from a server in the channel identified
by the given
*id*.
The message is written showing the given
*nick*
and a
*datetime*
timestamp with the hour, minute and second the message is
received.
The level is used to color the message, and the channel in the treeview
with different colors:

mention

> The message mentions the user in it's text and it will be written in
> purple.
> Also, the channel name in the servers treeview will be shown as
> purple.

message

> A chat message, coming from another user.
> The channel name is colored in orange.

info

> A message coming from the server, like
> "foo has joined",
> or
> "bar has quit".
> The channel is colored in blue.

If the quiet mode is active through, by being activated with the
**gui quiet**
command, messages of level info are suppressed.
The current mode may be visualized with
**gui showmode**.

**gui adduser**
and
**gui removeuser**
updates the users list of the channel
*id*
joined by the application user, by, respectively, adding a new user
or removing it.

"gui away"
marks the user in the various channel of the server identified by
*id*
as grey if
*status*
is 1
or enabled if
*status*
is 0.

**gui setmode**
marks the given
*nick*
in the channel
*id*
with the provided irc mode.
If
*nick*
is an operator, it's visualized in green.

**gui changech**
and
**gui raisewin**
are function used, generally, by the extensions.
Those are mapped by the custom IRC SWITCH and RAISE
commands.
SWITCH, select, programmatically, the channel identified by
*id*
and RAISE, show the application window.

**gui savefont**
saves the current font settings in the fonts configurations file.

# FILES

*${HOME}/.config/irctk/font.conf*

> Font configurations file

# SEE ALSO

irctk(1),
irctk-exts(n),
irctk-irc(n),
irctk-irctk(n),
irctk-log(n)

# AUTHORS

Andrea Biscuola &lt;[a@abiscuola.com](mailto:a@abiscuola.com)&gt;

OpenBSD 7.3 - September 3, 2023
