IRCTK-IRCTK(n) - n

# NAME

**irctk-irctk** - core processing namespace

# SYNOPSIS

**irctk connect** *network nick name pass cmd oldch*

**irctk extmsg** *msg*

**irctk findnetwork** *id*

**irctk getnetwork** *network*

**irctk init**

**irctk ischanrd** *chan channel*

**irctk killconnection** *id*

**irctk onexit**

**irctk partch** *chan channel*

**irctk pingserver** *chan*

**irctk privatechan** *chan nick*

**irctk reconnect** *chan*

**irctk quitserver** *chan*

**irctk save** *network nick name pass cmd*

**irctk writemsg** *chan id tags text loop*

# DESCRIPTION

The irctk namespace represent the heart of the whole
irctk(1)
application.
Input message processing, message sending, connections and channels
management along with the gluing with all the other namespaces
take place here.
It is initialized by calling the
**irctk init**
command and terminated upon application exiting with
**irctk onexit**.

After the initialization,
**irctk connect**
is called, serially, for all the IRC servers saved in the related configurations
file, also automatically joining all the channels saved from the previous
session.
A connection to an IRC server is initiated using the command specified in
*cmd*.
If the connection is successful, the command will proceed with requesting
IRCv3 capabilities and performing a login for the user.

If a connection dies, a reconnection is tried automatically with the
**irctk reconnect**
command, with the old details and channels automatically transported
to the new connection, if successfull.

**irctk killconnection**
explicitly kill an existing connection and start a reconnection process.

Once the login process is completed and the user joined one or more
channels,
**irctk writemsg**
is called from the GUI to send messages to an IRC server.
The message specified in
*text*
is sent to the target identified by
*id*
in its numeric form, on the server whose connection channel is
*chan*.
The message will be enriched with the given
*tags*,
a dictionary containing a series of key-value pairs identifying IRCv3 tags.
The
*loop*
variable must be set to 0, if we are sure that the message will not cause
a loop with the running extensions, or 1 if it is not the case.
The effect is, in the end, that the message will not be forwarded to the
extensions subsystem.

**irctk extmsg**
is the command called by the extensions subsystem when an extension
sends an irc message to the application.
The function take care of preparing and injecting the message in the
writing flow, to be sent to the server and shown to the user in the
interface.

**irctk findnetwork**
finds the communication channel associated with the network
*id*.
passed as argument.

**irctk partch**
frees all the resources associated with a specific channel upon leaving
it.

**irctk ischanrd**
Check if the
*channel*
in the network identified by the communication channel
*chan*
is of type
**read only**.

**irctk quitserver**
is used to destroy all the resources related to a specific server connection,
both from the running application and from the disk.
The server details are deleted forever.

**irctk getnetwork**
command, reads the
*network*
connection details from it's configurations file.

**irctk save**
is called whenever the application must store a connection informations
on its configuration file.

**irctk privatechan**
is called to create a private communication channel between the application
user and the IRC user identified by
*nick*

**irctk pingserver**
is used to periodically send a PING message, to check if the connection
is still alive.

# RETURN VALUES

**irctk findnetwork**
return the communication channel of the network identified by
*id*
or an empty list if nothing is found.

**irctk ischanrd**
return 1 if the channel is read only, or 0 if not.

**irctk getnetwork**
return the dictionary with the configurations for the given
*network*.

**irctk connect**
return the new communication channel for the network.

# FILES

*${HOME}/.config/irctk/auto/$net/connect.conf*

> Network configuration for automatic connection at startup.

*${HOME}/.config/irctk/auto/$net/join.conf*

> List of channels to join at startup.

# SEE ALSO

irctk(1),
irctk-exts(n),
irctk-gui(n),
irctk-irc(n),
irctk-log(n)

# AUTHORS

Andrea Biscuola &lt;[a@abiscuola.com](mailto:a@abiscuola.com)&gt;

OpenBSD 7.3 - August 24, 2023
