IRCTK-IRC(n) - n

# NAME

**irctk-log** - irctk irc conversations logging facility

# SYNOPSIS

**log close** *chan*

**log console** *text*

**log open** *network channel*

**log write** *chan nick msg timestamp*

# DESCRIPTION

The log namespace implements the functions to open, write and close a channel,
or private conversation, log file.

**log open**
will open, or create, a new log file for
*channel*
in the directory of the specified
*network*.

**log write**
writes a new log entry in the file identified by
*chan*.
*nick*
is the nickname of the user that sent the message,
*msg*
is the message text itself and
*timestamp*
is the date and time of the message as seconds from the UNIX epoch.
The message format as written in the log file is as following:

	YYYY-mm-ddTHH:MM:SS <nick>: message

**log console**
writes a generic log message on the application standard error channel.

**log close**
takes care of closing and releasing any resources that was in use by
*chan*.

# RETURN VALUES

**log open**
returns the channel descriptor for the opened file.

**log write**
and
**log close**
does not return any value.

# FILES

${HOME}/irc/logs

> IRC logs directory.

# SEE ALSO

irctk(1),
irctk-exts(n),
irctk-gui(n),
irctk-irc(n),
irctk-irctk(n)

# AUTHORS

Andrea Biscuola &lt;[a@abiscuola.com](mailto:a@abiscuola.com)&gt;

OpenBSD 7.3 - August 18, 2023
